Codeforces 106D Treasure Island

题目链接:点击打开链接

题意:

给定n*m的矩阵

# 是墙 . 和字母是平地

最多有26个字母(不重复出现)

下面k个指令,

每个指令代表移动的方向和步数。

若以某个字母为起点,依次执行所有的指令,任何过程都不会撞到墙或走出地图,则这个字母合法。

按字典序输出所有合法的字母。若没有字母合法则输出‘ no solution‘

预处理一下前缀和然后暴力。

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <string.h>
#include <math.h>
#include <vector>
#include <map>
using namespace std;
#define N 1005
vector<char>ans;
struct node{
    int x, y;
    char c;
    void put(){printf("(%d,%d) : %c\n", x, y, c);}
}a[30];
int step[4][2] = {-1,0, 1,0, 0,-1, 0,1};
int work[100005][2];
char s[N];
int mp[N][N], n, m, k, top, h[N][N], l[N][N];
bool okh(int H, int x, int y){return h[H][y]-h[H][x-1] == 0;}
bool okl(int L, int x, int y){return l[L][y]-l[L][x-1] == 0;}
bool ok(int x, int y, int i, int j){
    if(x>i)swap(x,i); if(y>j)swap(y,j);
    if(x==i)
        return okh(x, y, j);
    else
        return okl(y, x, i);
}
bool inmap(int x, int y){return 1<=x&&x<=n&&1<=y&&y<=m;}
bool judge(int x, int y){
    for(int i = 0; i < k; i++) {
        int ux = step[work[i][0]][0] * work[i][1] + x, uy = step[work[i][0]][1] *work[i][1] + y;
        if(!inmap(ux,uy))return false;
        if(!ok(x, y, ux, uy))return false;
        x = ux; y = uy;
    }
    return true;
}
void debug(){for(int i = 0; i < top; i++)a[i].put();}
void solve(){
 //   debug();
    ans.clear();
    for(int i = 0; i < top; i++)
        if(judge(a[i].x, a[i].y))
            ans.push_back(a[i].c);
    if(ans.size()==0){
        puts("no solution");
        return ;
    }
    sort(ans.begin(), ans.end());
    for(int i = 0; i < ans.size(); i++)printf("%c",ans[i]);
    puts("");
}
void input(){
    top = 0;
    memset(mp, 0, sizeof mp);
    memset(h, 0, sizeof h);
    memset(l, 0, sizeof l);
    for(int i = 1; i <= n; i++){
        scanf("%s", s+1);
        for(int j = 1; j <= m; j++)
        {
            if(s[j]=='#')
            {
                mp[i][j] = 1;
                h[i][j] = 1;
                l[j][i] = 1;
            }
            else if('A'<=s[j] && s[j]<='Z'){
                    a[top].x = i; a[top].y = j; a[top].c = s[j];
                    top++;
            }
        }
    }
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            h[i][j] += h[i][j-1];
    for(int i = 1; i <= m; i++)
        for(int j = 1; j <= n; j++)
            l[i][j] += l[i][j-1];
    scanf("%d",&k);
    for(int i = 0; i < k; i++){
        scanf("%s %d", s, &work[i][1]);
        if(s[0] == 'N') work[i][0] = 0;
        else if(s[0]=='S') work[i][0] = 1;
        else if(s[0]=='W') work[i][0] = 2;
        else work[i][0] = 3;
    }
}
int main(){
    while(~scanf("%d %d",&n,&m)){
        input();
        solve();
    }
    return 0;
}
时间: 2024-12-13 23:51:39

Codeforces 106D Treasure Island的相关文章

Gym 100971A Treasure Island BFS 思维题

A - Treasure Island Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Submit Status Description standard input/output Announcement Statements Pirate John Silver has found a map depicting exactly one island in a sea. The ma

Codeforces 106 D Treasure Island

题目链接~~> 做题感悟:这题做着很有感觉,从超时一直优化改到AC. 解题思路: 这题如果不预先处理图的话,单纯的模拟肯定超时,so ~需要预先处理图,因为向 N 和 S 是 y 不变,x 变化,向 W 和 E x 不变 ,变 y . 这样可以用两个 vector 然后分别存x 不变的时候 y 的值,y 不变的时候 x 的值,这样查询的时候直接固定 x ,或者 y 然后找变化的.复杂度为最大为 26 * 1000 * 1000 . 代码: #include<iostream> #incl

Codeforces Round #583 (Div. 1 + Div. 2, based on Olympiad of Metropolises), problem: (D) Treasure Island

题目大意 给你一个n*m 的棋盘 有的地方不能过 问题最少需要堵多少次 才能让(1,1)到(n,m)没有路径通过 解法: 打表发现 对角线最后剩下的通路最少 即为答案 画图可知$ 2*2$的子矩形内 右对角线被填满时左对角线都不能到达 递推判断即可 细节蛮多的 code: #include<stdio.h> #include<iostream> #include<cstring> #include<cmath> #include<stdio.h>

codeforces 495C. Treasure 解题报告

题目链接:http://codeforces.com/problemset/problem/495/C 题目意思:给出一串只有三种字符( ')','(' 和 '#')组成的字符串,每个位置的这个字符 '#'可以替换成不少于 1 个的 ')',问如何对每个'#'进行替换,使得对于字符串的任意一个位置, ')' 的数量始终不大于'(' 的数量.注意,'#'被替换成')'的总数以及原先有的')'的数量之和 == '(' 的总数. 花了两个晚上的一点时间,今天在图书馆里终于想到解决方案了,大感动 ~~~

CodeForces 494A Treasure(字符串匹配 思维)

http://codeforces.com/problemset/problem/494/A 题意 有一串字符串由 ( ) # 组成 #代表若干个 ) 问#具体为多少时可以使每个( 都对应一个 ) 思路 由于可以有多种方式组合 可以默认前 cnt-1 个 #号 与它前一个 ( 匹配 之后再对最后一个#进行特判(分别判断 #右边的num1 和左边的num2 如果num2-num1>0 则满足) #include<cstdio> #include<cstring> #includ

codeforces1214D Treasure Island

其实是一道水题,很显然答案一定是0.1.2中的某一个数 那么直接上dfs搜一遍,标记走过的点,如果这一次dfs不能到达终点,那么答案为0 否则再dfs一遍,dfs时不走标记过的点,如果这一次不能到达终点,那么答案为1 否则答案为2 #include <iostream> #include <stdio.h> #include <string.h> #include <stdlib.h> #define MAXN 1000010 using namespace

Codeforces1214D. Treasure Island (dp + Hash)

题目链接:传送门 思路: 仔细观察可以发现,答案最多就是2,只要把(2,1)和(1,2)堵住就可以了. 答案是0的情况就是初始状态下,(1,1)就已经不可达(n,m)了,很好判断. 所以重点就是区分答案为1和答案为2的情况. 如果答案为1的话,就说明从(1,1)到(n,m)的所有路径都经过同一个点(这样的点至少一个). 实际上,求出(1,1)出发可达的所有点的集合S1,和所有可达(n,m)的点S2.这里用dp来跑可以O(nm).其中坐标要压成一维的(因为n.m的范围没有给出),否则不好开内存.

推荐系统介绍:(协同过滤)—Intro to Recommender Systems: Collaborative Filtering

本文试验前期准备: MovieLens  ml-100k数据集 Jupyter notebook themoviedb.org API key     添加python引用 import numpy as np import pandas as pd 进入MovieLens  ml-100k数据存放目录 cd F:\Master\MachineLearning\kNN\ml-100k 读取数据:u.data每行数据分为userid,itemid,rating,时间戳四部分 names = ['u

Codeforces GYM 100114 B. Island 水题

B. Island Time Limit: 1 Sec Memory Limit: 256 MB 题目连接 http://codeforces.com/gym/100114 Description On February 30th this year astronauts from the International Space Station flew over the Pacific Ocean and took a picture, on which was discovered a pr